set queue [lindex $argv 0]
set ecn [lindex $argv 1]
set rate [lindex $argv 2]
set rate1 [lindex $argv 3]
set freq [lindex $argv 4]
set freq1 [lindex $argv 5]
set flows [lindex $argv 6]
set flowtype1 [lindex $argv 7]
set flowtype2 [lindex $argv 8]
set increase [lindex $argv 9]
set decrease [lindex $argv 10]
set k_param [lindex $argv 11]
set l_param [lindex $argv 12]
set discount [lindex $argv 13]
set numsample [lindex $argv 14]   
set conservative [lindex $argv 15]
set stoptime [lindex $argv 16]

puts "queue:$queue ecn:$ecn rate:$rate rate1:$rate1 freq:$freq freq1:$freq1 flows:$flows flowtype1:$flowtype1 flowtype2:$flowtype2 increase:$increase decrease:$decrease k_param:$k_param l_param:$l_param discount:$discount numsample:$numsample stoptime:$stoptime"

set ns [new Simulator]
set node_(r1) [$ns node]
set node_(r2) [$ns node]
$ns duplex-link $node_(r1) $node_(r2) $rate 20ms $queue
set slink [$ns link $node_(r1) $node_(r2)]
set fmon [$ns makeflowmon Fid]
$ns attach-fmon $slink $fmon 

Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

set wf [open out.w w]
set wq [open out.q w]
set wd [open out.d w]
set thru [open tmpthru w] 
set dropval [expr 0]
set depval [expr 0] 

# Uncomment the following line to randomize runs using a random seed
ns-random 0     

set redq [[$ns link $node_(r1) $node_(r2)] queue]
set len [string length $rate]
set rate_w_mb [string range $rate 0 [expr $len-3]]
set len [string length $rate1]
set rate1_w_mb [string range $rate1 0 [expr $len-3]]
set limit [expr 2.5*$rate_w_mb*50/8.0]
$ns queue-limit $node_(r1) $node_(r2) $limit
if {$queue=="RED"} {
    $redq set thresh_ [expr 0.25*$rate_w_mb*50/8.0]
    $redq set maxthresh_ [expr 1.25*$rate_w_mb*50/8.0]
}
if {$queue=="DropTail"} {
    $redq set thresh_ $limit
    $redq set maxthresh_ $limit
}

puts "queue:$queue limit:$limit thresh_:[$redq set thresh_] maxthresh_:[$redq set maxthresh_]"  

# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRC set printStatus_ 0
Agent/TFRC set conservative_ $conservative 
Agent/TFRCSink set discount_ $discount
Agent/TFRCSink set printLoss_ 0
Agent/TFRCSink set smooth_ 1
Agent/TFRCSink set NumSamples_ $numsample
Agent/TCP/Sack1 set packetSize_ 1000
Agent/TCP/Sack1 set window_ 1000
Agent/TCP set precisionReduce_ true

for {set i 0} {$i < $flows} {incr i} {

    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac  

    set node_(s$i) [$ns node]
    set node_(k$i) [$ns node]
    set node_(snew$i) [$ns node]
    set node_(knew$i) [$ns node]
    $ns duplex-link $node_(s$i) $node_(r1) 100Mb 2ms DropTail
    $ns duplex-link $node_(k$i) $node_(r2) 100Mb [expr ($i+1)/5]ms DropTail
    $ns duplex-link $node_(snew$i) $node_(r1) 100Mb 2ms DropTail
    $ns duplex-link $node_(knew$i) $node_(r2) 100Mb [expr ($i+1)/5]ms DropTail
    if {$flowtype1=="TFRC"} {
	#check 0,1 here
	set tf($i) [$ns create-connection TFRC $node_(s$i) TFRCSink $node_(k$i) 0]
	$ns at $starttime "[set tf($i)] start"
	$ns at 10.0 "set sval($i) [$tf($i) set ndatapack_]"
	$ns at $stoptime "[set tf($i)] stop"
    }
    if {$flowtype1=="BIN"} {
	set tf($i) [$ns create-connection TCP/Sack1 $node_(s$i) TCPSink/Sack1 $node_(k$i) 1]
	[set tf($i)] set increase_num_ $increase
	[set tf($i)] set decrease_num_ $decrease
 	[set tf($i)] set k_parameter_ $k_param
	[set tf($i)] set l_parameter_ $l_param
	[set tf($i)] set windowOption_ 6
	set ftptf($i) [[set tf($i)] attach-app FTP]
	$ns at $starttime "[set ftptf($i)] start"
	$ns at 10.0 "set sval($i) [$tf($i) set ack_]"
	$ns at $stoptime "[set ftptf($i)] stop"
    }
    if {$flowtype1=="GAIMD"} {
	set tf($i) [$ns create-connection TCP/Sack1 $node_(s$i) TCPSink/Sack1 $node_(k$i) 1]
	[set tf($i)] set increase_num_ $increase
	[set tf($i)] set decrease_num_ $decrease
	set ftptf($i) [[set tf($i)] attach-app FTP]
	$ns at $starttime "[set ftptf($i)] start"
	$ns at 10.0 "set sval($i) [$tf($i) set ack_]"
	$ns at $stoptime "[set ftptf($i)] stop"
    }

    if {$flowtype1=="TCP"} {
	set tf($i) [$ns create-connection TCP/Sack1 $node_(s$i) TCPSink/Sack1 $node_(k$i) 1]
	set ftptf($i) [[set tf($i)] attach-app FTP]
	$ns at $starttime "[set ftptf($i)] start"
	$ns at 10.0 "set sval($i) [$tf($i) set ack_]"
	$ns at $stoptime "[set ftptf($i)] stop"
    }



    if {$flowtype2=="TFRC"} {
	#check 0,1 here
	set tfnew($i) [$ns create-connection TFRC $node_(snew$i) TFRCSink $node_(knew$i) 0]
	$ns at $starttime "[set tfnew($i)] start"
	$ns at 10.0 "set svalnew($i) [$tfnew($i) set ndatapack_]"
	$ns at $stoptime "[set tfnew($i)] stop"
    }
    if {$flowtype2=="BIN"} {
	set tfnew($i) [$ns create-connection TCP/Sack1 $node_(snew$i) TCPSink/Sack1 $node_(knew$i) 1]
	[set tfnew($i)] set increase_num_ $increase
	[set tfnew($i)] set decrease_num_ $decrease
 	[set tfnew($i)] set k_parameter_ $k_param
	[set tfnew($i)] set l_parameter_ $l_param
	[set tfnew($i)] set windowOption_ 6
	set ftptfnew($i) [[set tfnew($i)] attach-app FTP]
	$ns at $starttime "[set ftptfnew($i)] start"
	$ns at 10.0 "set svalnew($i) [$tfnew($i) set ack_]"
	$ns at $stoptime "[set ftptfnew($i)] stop"
    }
    if {$flowtype2=="GAIMD"} {
	set tfnew($i) [$ns create-connection TCP/Sack1 $node_(snew$i) TCPSink/Sack1 $node_(knew$i) 1]
	[set tfnew($i)] set increase_num_ $increase
	[set tfnew($i)] set decrease_num_ $decrease
	set ftptfnew($i) [[set tfnew($i)] attach-app FTP]
	$ns at $starttime "[set ftptfnew($i)] start"
	$ns at 10.0 "set svalnew($i) [$tfnew($i) set ack_]"
	$ns at $stoptime "[set ftptfnew($i)] stop"
    }

    if {$flowtype2=="TCP"} {
	set tfnew($i) [$ns create-connection TCP/Sack1 $node_(snew$i) TCPSink/Sack1 $node_(knew$i) 1]
	set ftptfnew($i) [[set tfnew($i)] attach-app FTP]
	$ns at $starttime "[set ftptfnew($i)] start"
	$ns at 10.0 "set svalnew($i) [$tfnew($i) set ack_]"
	$ns at $stoptime "[set ftptfnew($i)] stop"
    }
    
    
    $ns at 10.0 "set dropval [expr [$fmon set pdrops_]]"
    $ns at 10.0 "set depval [expr [$fmon set pdepartures_]]"
}

proc stop {} {
    global ns tf tfnew sval svalnew thru freq freq1 wq wd dropval depval
    global flowtype1 flowtype2 fmon flows

    set linkuti [expr [$fmon set pdepartures_]-$depval]
    set linkdrop [expr [$fmon set pdrops_]-$dropval]
    set droprate [expr $linkdrop./($linkuti.+$linkdrop.)]

    for {set i 0} {$i < $flows} {incr i} {
	if {$flowtype1=="TFRC"} {
	    set thruput1 [expr [$tf($i) set ndatapack_]-$sval($i)]
	} else {
	    set thruput1 [expr [$tf($i) set ack_]-$sval($i)]
	}
	if {$flowtype2=="TFRC"} {
	    set thruput2 [expr [$tfnew($i) set ndatapack_]-$svalnew($i)]
	} else {
	    set thruput2 [expr [$tfnew($i) set ack_]-$svalnew($i)]
	}
	if {$flowtype1==$flowtype2} {
	    puts $thru "$freq $freq1 $flowtype1 $flowtype2 $thruput1 $droprate"
	    puts $thru "$freq $freq1 $flowtype1 $flowtype2 $thruput2 $droprate"
	} else {
	    puts $thru "$freq $freq1 $flowtype1 $flowtype2 $thruput1 $thruput2 $droprate"
	}

    }

    close $wq
    close $wd
    close $thru
    exit
}

#configure cbr source
Application/Traffic/CBR set rate_ [expr $rate_w_mb-$rate1_w_mb]Mb
puts "cbr rate [Application/Traffic/CBR set rate_]"
set udp0 [new Agent/UDP]
set node_(scbr) [$ns node]
set node_(kcbr) [$ns node]
$ns duplex-link $node_(scbr) $node_(r1) 100Mb 2ms DropTail
$ns duplex-link $node_(kcbr) $node_(r2) 100Mb 2ms DropTail
$ns attach-agent $node_(scbr) $udp0
set cbr(0) [new Application/Traffic/CBR]
$cbr(0) attach-agent $udp0
set null0 [new Agent/Null]
$ns attach-agent $node_(kcbr) $null0
$ns connect $udp0 $null0         

proc changebw {} {
    global ns freq freq1 node_ rate rate1 queue fmon drop1 dep1 drop2 dep2 cbr
#    puts "changebw called"
    $ns at [expr [$ns now]+$freq1] "$cbr(0) start"
    $ns at [expr [$ns now]+$freq+$freq1] "changebw"
    $ns at [expr [$ns now]+$freq+$freq1] "$cbr(0) stop"
}         

$ns at 0.0 "changebw"  

set randomflows 4
if {$randomflows > $flows} {
    set randomflows $flows
}
for {set i 0} {$i < $randomflows} {incr i} {
    set tcp$i [$ns create-connection TCP/Sack1 $node_(k$i) TCPSink/Sack1 $node_(s$i) 1]
    [set tcp$i] set window_ 8
    set ftp$i [[set tcp$i] attach-app FTP]
    $ns at $i "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}

$ns at $stoptime "stop"

$ns run










